
if (typeof NXThemesStyleEditor == "undefined") {
    NXThemesStyleEditor = {
        'currentProperty': null
    };
}

NXThemesStyleEditor.refreshPreview = function() {
    var previewArea = document.getElementById('stylePreviewArea');
    var element  = previewArea.getAttribute('element');
    NXThemesStyleEditor.renderElement(element, previewArea);
};

NXThemesStyleEditor.refreshCssPreview = function() {
    Seam.Component.getInstance("nxthemesEditorAction").renderCssPreview(
       'stylePreviewArea', NXThemesStyleEditor.refreshCssPreviewCallback);
};

NXThemesStyleEditor.refreshCssPreviewCallback = function(result) {
    $('previewCss').innerHTML = result;
};

NXThemesStyleEditor.closeStylePicker = function() {
    NXThemes.getControllerById('style editor perspectives').switchTo('default');
};

NXThemesStyleEditor.renderElement = function(id, area) {
    // render an element inside an area
    var url = window.location.pathname;
    var options = {
      method: "post",
      onComplete: function(req) {
        var temp = document.createElement("div");
        temp.innerHTML = req.responseText;
        var elementList = $(temp).getElementsBySelector('#' + id);
        if (elementList.length > 0) {
          var element = elementList[0];
          area.innerHTML = element.innerHTML;
        }
      }
    };
    var parts = url.split('?');
    var parameters = '?engine=fragments-only';
    var method = url;
    if (parts.length == 2) {
      method = parts[0];
      parameters = '&' + parts[1];
    }
    options.parameters = parameters;
    new Ajax.Request(method, options);
};

NXThemesStyleEditor.chooseStyleSelector = function(select) {
  var value = select.value;
  if (value === '') {
    value = null;
  }
  NXThemesStyleEditor.setStyleSelector(select.value);
};

NXThemesStyleEditor.setPresetGroup = function(select) {
    Seam.Component.getInstance("nxthemesEditorAction").setPresetGroup(
       select.value, NXThemesStyleEditor.refreshStylePicker);
};

NXThemesStyleEditor.setStyleSelector = function(selector) {
    Seam.Component.getInstance("nxthemesEditorAction").setCurrentStyleSelector(
       selector, NXThemesStyleEditor.refreshEditor);
};

NXThemesStyleEditor.createStyle = function() {
    Seam.Component.getInstance("nxthemesEditorAction").createStyle(
       NXThemesStyleEditor.createStyleCallback);
};

NXThemesStyleEditor.createStyleCallback = function(result) {
  NXThemes.getViewById("element style").refresh();
  NXThemesEditor.writeMessage("New style created for this element.");
};

NXThemesStyleEditor.toggleIgnoreWidgetView = function() {
    Seam.Component.getInstance("nxthemesEditorAction").toggleIgnoreWidgetView(
       NXThemesStyleEditor.refreshEditor);
};

NXThemesStyleEditor.getSelectorInContext = function(element, context) {
  if (element == context) {
    return "";
  }
  var i, node, tag, name, selector, classnames;
  node = element;

  // If no context is passed, use the document itself.
  if (!context) {
    context = document;
  }

  // start from the first contained element
  context = context.childNodes.item(0);

  var selectors = new Array();
  while (node) {
    if (node == context) {
      break;
    }
    tag = node.tagName;
    if (!tag) {
      break;
    }
    tag = tag.toLowerCase();
    classnames = node.className;
    name = '';
    if (classnames) {
      name = classnames.replace(' ', '.');
    }
    selector = name ? tag + '.' + name : tag;
    // ignore tags that have the "ignore" attribute set
    if (!node.getAttribute("ignore")) {
      selectors.push(selector);
    }
    node = node.parentNode;
  }

  // reverse the array
  selectors.reverse();
  return selectors.join(" ");
};

NXThemesStyleEditor.refreshEditor = function() {
  NXThemes.getViewById("element style").refresh();
};

NXThemesStyleEditor.selectTag = function(info) {
    var target = info.target;
    Event.stop(info);
    var area = $('stylePreviewArea');
    var selector = NXThemesStyleEditor.getSelectorInContext(target, area);
    NXThemesStyleEditor.setStyleSelector(selector);
    return false;
};

NXThemesStyleEditor.setCurrentStyleLayer = function(uid) {
    Seam.Component.getInstance("nxthemesEditorAction").setCurrentStyleLayer(uid,
        NXThemesStyleEditor.refreshEditor);
};

NXThemesStyleEditor.pickPropertyValue = function(info) {
    var target = info.target;
    var category = target.getAttribute('category');
    NXThemesStyleEditor.currentProperty = target.getAttribute('property');
    Seam.Component.getInstance("nxthemesEditorAction").setStyleCategory(category,
        NXThemesStyleEditor.pickPropertyValueCallback);
};

NXThemesStyleEditor.setStyleEditMode = function(mode, fromMode) {
    if (fromMode == 'form') {
      NXThemesEditor.updateElementStyle();
    }
    if (fromMode == 'css') {
      NXThemesEditor.updateElementStyleCss();
    }
    Seam.Component.getInstance("nxthemesEditorAction").setStyleEditMode(mode,
        NXThemesStyleEditor.refreshEditor);
};

NXThemesStyleEditor.setStylePropertyCategory = function(category) {
    Seam.Component.getInstance("nxthemesEditorAction").setStylePropertyCategory(category,
        NXThemesStyleEditor.refreshEditor);
};

NXThemesStyleEditor.updateFormField = function(value) {
  var currentProperty = NXThemesStyleEditor.currentProperty;
  if (currentProperty !== null) {
    var propertyName = 'property:' + currentProperty;
    var inputs = Form.getInputs('nxthemesElementStyle', null, propertyName);
    if (inputs !== null) {
      inputs[0].value = value;
    }
  }
  NXThemesStyleEditor.closeStylePicker();
};

NXThemesStyleEditor.pickPropertyValueCallback = function() {
    NXThemes.getControllerById('style editor perspectives').switchTo('style picker');
};

NXThemesStyleEditor.refreshStylePicker = function() {
    NXThemes.getViewById("style picker").refresh();
};

// widgets
NXThemes.registerWidgets({

  stylepreview: function(def) {
    var widget = NXThemes.Canvas.createNode({
      tag: 'div',
      classes: 'nxthemesStylePreview'
    });
    return new NXThemesStyleEditor.StylePreview(widget, def);
  }

});

NXThemesStyleEditor.StylePreview = Class.create();
NXThemesStyleEditor.StylePreview.prototype = Object.extend(new NXThemes.View(), {

  setup: function() {
    NXThemesStyleEditor.refreshPreview();
    NXThemesStyleEditor.refreshCssPreview();
  }

});

// actions
NXThemes.addActions({
  'select style tag': NXThemesStyleEditor.selectTag,
  'update style label': function(info) {
    var box = $('labelInfo');
    if (box === null) {
      return;
    }
    var x = Event.pointerX(info);
    var y = Event.pointerY(info);
    var target = info.target;
    var label= NXThemesStyleEditor.getSelectorInContext(target, $('stylePreviewArea'));
    if (!label) {
      label = '.';
    }
    box.innerHTML = label;
    box.setStyle({left: x+'px', top: y-45+'px'});
    box.show();
  },
  'hide style label': function(info) {
    $('labelInfo').hide();
  },
  'pick property value': NXThemesStyleEditor.pickPropertyValue
});



